
#include<stdlib.h>
#include<stdio.h>
#include<ctype.h>
#include"drzewo.h" 
#define MAX 300


/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  getword
 *  Description:  Pobiera wyraz ze strumienia 'f' i umieszcza go w 's'.
 *  Wyraz to ciag liter [a-zA-Z]. Funkcja pomija wszystkie poczatkowe znaki nie bedace 
 *  literami. Funkcja konczy dzialanie po przeczytaniu pierwszego wyrazu, lub po wczytaniu 
 *  'n' znakow, lub gdy napotka EOF.
 *  Wartoscia zwracana jest dlugosc wyrazu.
 * =====================================================================================
 */
int getword(FILE *f,char *s,int n)
{
   int c, i=0;
   
   /*  Najpierw pomijamy znaki ktore nie sa literami */
   while((c=fgetc(f))!=EOF && !isalpha(c)) ;
   
   if(c!=EOF) 
   {
      s[i]=tolower(c);
      i++;
      
      /* Czytamy wyraz, ciag liter */
      while((c=fgetc(f))!=EOF && isalpha(c) && i<n-1) 
      {
         s[i]=tolower(c);
         i++;
      }
   }
   s[i]='\0';

   return i;
}


int main(int argc, char **argv)
{
   struct tree *d=NULL;
   char word[MAX];
   FILE *file=NULL;

   if (argc == 2) file=fopen(argv[1],"r");
   else file = stdin;

   if(!file) return 1;

   while(getword(file,word,MAX)>0) d=add(d,word);

   print(d);
   free_tree(d);
   d=NULL;

   if (file!=stdin) fclose(file);

   return 0;
}
